use serde::Deserialize;
use crate::{err::Error, Result};

#[derive(Deserialize)]
pub struct MysqlConfig {
    pub dsn: String,
    pub max_cons: u32,
}


#[derive(Deserialize)]
pub struct WebConfig {
    pub addr: String,
}


#[derive(Deserialize)]
pub struct AppConfig {
    pub mysql: MysqlConfig,
    pub web: WebConfig,
}

impl AppConfig {
    pub fn from_env() -> Result<Self> {
        config::Config::builder()
            .add_source(config::Environment::default())
            .build()
            .map_err(Error::from)?
            .try_deserialize()
            .map_err(Error::from)
    }
}

